package com.crudoperation.Service;
import org.junit.jupiter.api.Assertions;
import org.mockito.Mock;
import org.mockito.InjectMocks;
import java.util.stream.Stream;
import org.junit.jupiter.api.Test;
import java.util.stream.Collectors;

import static org.assertj.core.api.AssertionsForClassTypes.assertThat;
import static org.junit.jupiter.api.Assertions.assertFalse;

import com.crudoperation.Model.Student;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.Mockito;
import org.mockito.junit.jupiter.MockitoExtension;
import com.crudoperation.Repository.StudentRepository;
import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.mockito.Mockito.*;
import com.crudoperation.Model.Student;

@ExtendWith(MockitoExtension.class)
class StudentServiceImplTest {

    @InjectMocks
    private  StudentServiceImpl studentServiceImpl;
    @Mock private StudentRepository studentRepository;

    @Test
    public void getAllStudents() {
        when(studentRepository.findAll()).thenReturn(Stream.of(new Student(1, "101", "Suresh"), new Student(2, "102", "Rayyan Hasan")).collect(Collectors.toList()));
        assertEquals(2, studentServiceImpl.getAllStudents().size());
    }

    @Test
    void getStudentByID() {
    Student s3 = new Student(3, "103", "M_Ameen");
    when(studentRepository.findById(3)).thenReturn(s3);

    Student studentResult = studentServiceImpl.getStudentByID(3);
        assertEquals(s3, studentResult);
    }

    @Test
    void addStudent() {
        //GIVEN
        Student st2  = new Student(2, "102", "Rayyan Hasan");
        when(studentRepository.save(st2)).thenReturn(st2);

        //WHEN
        Student studentResult = studentServiceImpl.addStudent(st2);

        //THEN
        assertEquals(st2, studentResult);
    }

    @Test
    void updateStudent() {
        Student student = new Student();
        student.setSid(3);
        student.setRno("103");
        student.setName("Danish");
        Mockito.when(studentRepository.save(student)).thenReturn(null);
       // Assertions.assertEquals(student, student.getSid());
        student.setName("Suresh");
       Mockito.when(studentRepository.save(student)).thenReturn(student);
       assertEquals(student, studentServiceImpl.updateStudent(student, student.getSid()));

    }


    @Test
   public void deleteStudentById() {
        
        Student studentdelete = new Student(5, "105", "Suresh Kumar");
        studentServiceImpl.deleteStudentById(studentdelete.getSid());
        verify(studentRepository, times(1)).deleteById(5);


    }

}